from bud import Bud

# oppgave 4b)
class Annonse :
    def __init__(self,annTekst) :
        self._annTekst = annTekst
        self._mineBud = []

    def hentTekst(self) :
        return self._annTekst

    def giBud(self,hvem,belop) :
        nyttBud = Bud(hvem,belop)
        self._mineBud.append(nyttBud)

    def antBud(self) :
        return len(self._mineBud)

    def hoyesteBud(self) :
        if self.antBud() == 0 :
            return None
        hoytBud = self._mineBud[0]
        for b in self._mineBud[1:self.antBud()] :
            # '>' mellom objektene er OK pga metoden __gt__ i Bud
            if b > hoytBud :
                hoytBud = b
        return hoytBud

# oppgave 4e)
# Oppgaveteksten spesifiserer ikke hva som skal gjøres dersom
# max-grense er mindre eller lik høyeste bud hittil. Her har alle
# løsninger fått uttelling, så lenge det blir lagt inn riktig
# bud både når budet kan økes over høyeste, og når det ikke trengs.
    def kraftBud(self,hvem,belop,max) :
        if self.hoyesteBud() != None :
            hoyesteBelop = self.hoyesteBud().hentBudStr()
            if hoyesteBelop >= belop and hoyesteBelop < max :
                belop = hoyesteBelop + 1
        self.giBud(hvem,belop)

# til oppgave 4g)
    def tellLave(self) :
        if self.antBud() <= 1 :
            return 0
        teller = 0
        hoyesteHittil = self._mineBud[0]
        for i in range(1,self.antBud()) :
            # '>' mellom Bud-objekter er ok siden metoden
            #  __gt__ er definert i klassen Bud
            if hoyesteHittil > self._mineBud[i] :
                teller += 1
            else :
                hoyesteHittil = self._mineBud[i]
        return teller

# Ikke bedt om i eksamensoppgaven
    def __str__(self) :
        streng = "Annonsetekst: " + self.hentTekst() + ".     Bud:"
        for b in self._mineBud :
            streng += "\n             " + str(b)
        return streng
